/*
 *  unpack.c -- unpack TypedInputStream.
 *
 *  20-feb-2001 / gmt  original using getc/ungetc
 *  23-jul-2001 / gmt  use peekValue() instead
 *
 *  Reads from stdin a TypedInputStream and decodes it to stdout.
 *  Only integers, strings, and nulls are handled -- no floating point.
 */

#include <stdio.h>
#include <stdlib.h>
#include "tstream.h"

#define MAXSTR 1000

int main(int argc, char *argv[]) {
    char buf[MAXSTR];
    long value;

    for (;;) {
	switch (peekValue(stdin)) {
	    case 'e':				/* EOF */
		return 0;
	    case 'n':				/* null */
		printf("null\n");
		break;
	    case 's':				/* string */
		readString(stdin, buf, MAXSTR);
		printf("\"%s\"\n", buf);
		break;
	    case 'i':				/* integer */
		readInteger(stdin, &value);
		printf("%ld\n", value);
		break;
	    default:				/* unknown */
		fprintf(stderr, "unrecognized type\n");
		exit(1);
	}
    }
}
