/*
 * alloc.c --
 *
 *	This file implements memory allocation and deallocation.
 */

static char rcsid[] =
"$Id: alloc.c,v 1.2 2001/07/03 21:46:25 gmt Exp $";
 
#include "tokInt.h"

/*  TokAlloc(nbytes) -- allocate n bytes with error checking  */

void *
TokAlloc(size_t nbytes) {
    void *p = malloc(nbytes);
    if (!p)
	TokAbort("out of memory");
    return p;
}

/*  TokSalloc(s) -- allocate and initialize string  */

char *
TokSalloc(char *s) {
    return strcpy(TokAlloc(strlen(s) + 1), s);
}

/*  TokZalloc(nbytes) -- allocate n zeroed bytes with error checking  */

void *
TokZalloc(size_t nbytes) {
    void *p = calloc(1, nbytes);
    if (!p)
	TokAbort("out of memory");
    return p;
}

/*  TokRealloc(p, nbytes) -- realloc p to size nbytes with error checking  */

void *
TokRealloc(void *p, size_t nbytes) {
    p = realloc(p, nbytes);
    if (!p)
	TokAbort("out of memory");
    return p;
}

/*  TokFree(p) -- free memory associated with object p, if non-null  */

void
TokFree(void *p) {
    free(p);
}
