/*
 * tok.h --
 *
 *	This header file describes the externally-visible facilities
 *	of the token client.
 *
 * $Id: tok.h,v 1.2 2001/07/03 21:46:26 gmt Exp $
 */

#ifndef _TOK
#define _TOK

#define TOK_VERSION "1.0"
#define TOK_MAJOR_VERSION 1
#define TOK_MINOR_VERSION 0

#define TOK_SHARED 1
#define TOK_EXCLUSIVE -1

typedef struct TokToken *Tok_Token;
typedef struct TokService *Tok_Service;



/*
 * Prototypes:
 */

char **		Tok_Config(char *cfgfile);
Tok_Service	Tok_Open(char **servers);
void		Tok_Close(Tok_Service svc);

Tok_Token	Tok_Request(Tok_Service svc, char *name, int how,
			void (*callback)(Tok_Token t, void *arg), void *arg);
void		Tok_SetData(Tok_Token t, void *data, int length);
void		Tok_Update(Tok_Token t);
void		Tok_Release(Tok_Token t);

void *		Tok_GetData(Tok_Token t);
int		Tok_GetLength(Tok_Token t);
char *		Tok_GetName(Tok_Token t);
int		Tok_GetAccess(Tok_Token t);
void		(*Tok_GetCallback(Tok_Token t))(Tok_Token, void *);
void *		Tok_GetArgument(Tok_Token t);


#endif /* _TOK */
