//  tPickle.java -- tests the Pickle class


import topovista.toksvc.*;


class tPickle {


static long vals[] = {
    0, 1, 2, 3, 4, 5, 6, 7, 11, 13, 17, 19, 23, 29, 30, 31, 32, 33, 34, 37,
    41, 43, 47, 62, 63, 64, 65, 66, 67, 91, 127, 128, 129, 130, 131, 173,
    229, 254, 255, 256, 257,  271, 331, 383, 419, 491, 511, 512, 513, 777,
    0x0345, 0x03FF, 0x0400, 0x0401,
    0x0567, 0x07FF, 0x0800, 0x0801,
    0x0999, 0x0FFF, 0x1000, 0x1001,
    0x1234, 0x1FFF, 0x2000, 0x2001,
    0x3579, 0x3FFF, 0x4000, 0x4001,
    0x6789, 0x7FFF, 0x8000, 0x8001,
    0xBACE, 0xFFFF, 0x10000, 0x10001,
    0x123456, 0xFFFFFF, 0x1000000, 0x1000001,
    0x12345678L, 0xFFFFFFFFL, 0x100000000L, 0x100000001L,
    0x123456789AL, 0xFFFFFFFFFFL, 0x10000000000L, 0x10000000001L,
    0x123456789ABCL, 0xFFFFFFFFFFFFL, 0x1000000000000L, 0x1000000000001L,
    0x123456789ABCDEL, 0x456789ABCDEF01L, 0x9ABCDEF0123456L,
    0xFFFFFFFFFFFFFFL, 0x100000000000000L, 0x100000000000001L,
    0x123456789ABCDEF0L,
    0x1FFFFFFFFFFFFFFFL, 0x2000000000000000L, 0x2000000000000001L,
    0x3FFFFFFFFFFFFFFFL, 0x4000000000000000L, 0x4000000000000001L,
    0x7FFFFFFFFFFFFFFFL, 0x8000000000000000L, 0xFFFFFFFFFFFFFFFFL,
};

static String strs[] = {
    "", " ", "a", "bc", "def", "ghijklm", "nopqrstuv",
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
    "\nSo rested he by the Tumtum tree, And stood awhile in thought.",
};



public static void main(String args[]) throws Exception {

    Pickle p = new Pickle();
    for (int i = 0; i < vals.length; i++) {
	p.put(vals[i]);
	p.put(-vals[i]);
    }
    for (int i = 0; i < strs.length; i++) {
	p.put(strs[i]);
    }

    byte[] b = p.toByteArray();
    System.out.println("Pickled size: " + b.length);
    p = new Pickle(b);

    System.out.println();
    for (int i = 0; i < vals.length; i++) {
	long v1 = vals[i];
	long v2 = p.getLong();
	long v3 = p.getLong();
	if (v1 != v2 || v1 != -v3) {
	    System.out.print("ERROR>\t");
	}
	System.out.println(v1 + " " + v2 + " " + v3);
    }

    System.out.println();
    for (int i = 0; i < strs.length; i++) {
	String s = strs[i];
	String t = p.getString();
	if (! s.equals(t)) {
	    System.out.print("ERROR>\t");
	}
	System.out.println("<" + s + "> <" + t + ">");
    }
}


} // class tPickle
