package topovista.explorer;

/**
 *  Implements a spiral walk from the starting point.
 */

class SpiralWalk extends Explorer {

    int dir = 0;			// direction
    int edgnum = 0;			// edge number
    int nsteps = 1;			// number of steps left



SpiralWalk() {
    super('s', "spiral");
}



public void init() {
    edgnum = 0;
    nsteps = 1;
    int dir = (int) (4 * Math.random());
}



public Cell nextLoc(World w, Cell curr) {

    if (nsteps == 0) {
	edgnum++;
	nsteps = edgnum / 2 + 1;
	dir = (dir + 1) % 4;
    }
    nsteps--;
    switch (dir) {
	case 0:  return w.find(curr.zone, curr.x + 1, curr.y, curr.k);
	case 1:  return w.find(curr.zone, curr.x, curr.y + 1, curr.k);
	case 2:  return w.find(curr.zone, curr.x - 1, curr.y, curr.k);
	case 3:  return w.find(curr.zone, curr.x, curr.y - 1, curr.k);
    }
    return null; /*NOTREACHED*/
}



} // class SpiralWalk
