package topovista.rpserver;

import java.net.*;
import java.util.*;



/**
 *  Represents a TopoVista client that has sent us requests.
 */
class Client implements TVRP {

private static Hashtable ctable = new Hashtable();  /* table of all clients */

    SocketAddress addr;			/* address identifying this client */
    Message latest;			/* last request message received */
    LinkedList done;			/* messages recently answered */


/**
 *  Constructs a client object.
 *  Clients are uniquely identified by their source addresses.
 */
private Client(SocketAddress addr) {
    this.addr = addr;
    this.done = new LinkedList();
}



/**
 *  Finds a client in the local database, creating a new entry if necessary.
 */
public static Client lookup(SocketAddress addr) {
    Client c = (Client) ctable.get(addr);
    if (c == null) {
	c = new Client(addr);
	ctable.put(addr, c);
    }
    return c;
}



/**
 *  Returns a string representation of this client.
 */
public String toString() {
    return "Client(" + addr + ")";
}



} // class Client
