package topovista.rpserver;

/**
 *  Symbolic constants for use with TVRP (TopoVista Router Protocol).
 */

public interface TVRP {



public final static int DEF_PORT = 4747;	// default port number

public final static int REQ_MAX = 65536;	// maximum request message size

public final static int NOREPEAT_MSEC = 500;	// don't resend faster than this

public final static int CLEANER_MSEC = 619;	// run cleaner this often

public final static int CLIENT_DEAD_SEC = 150;	// time to discard client msgs


//  record word layout in request and response messages

public final static int INFO_HEADER = 12;	// length of INFO reply header

public final static int RECS_BITS = 26;		// bits specifying tile records
public final static int RECS_SHIFT = 0;		// shift count for those bits
public final static int RECS_MASK = 0x03FFFFFF;	// mask for those bits

public final static int PRI_MAX   = 63;		// maximum request priority
public final static int PRI_BITS  = 6;		// size of priority in bits
public final static int PRI_SHIFT = RECS_BITS;	// shift offset of priority
public final static int PRI_MASK  = 0xFC000000;	// mask for priority bits

public final static int UNAV_MASK = 0x80000000;	// mask for UNAVAILABLE bit



} // interface TVRP
