//  ConfirmMessage.java -- acknowledge ReturnMessage.


package topovista.toksvc;

import java.net.*;



/**
 *  A ConfirmMessage acknowledges a ReturnMessage.
 */
class ConfirmMessage extends Message {

    long msgnum;			// arbitrary client message number



final static int MTYPE = 25;	// type code for this message class



/**
 *  Constructor for synthesizing a new message.
 */
ConfirmMessage(long msgnum, String name) {
    super(MTYPE);
    this.msgnum = msgnum;
}



/**
 *  Adds the encoding of this object to a Pickle.
 */
Pickle pickle(Pickle p) {
    super.pickle(p);
    p.put(msgnum);
    return p;
}



/**
 *  Constructs a ConfirmMessage by reading from a Pickle.
 */
ConfirmMessage(Pickle p) {
    super(p);
    msgnum = p.getInt();
}



/**
 *  Returns a string representation of this message.
 */
public String toString() {
    return super.toString() + "(" + msgnum + ")";
}



}  // class ConfirmMessage
