//  expt2.java -- tests Server protocols

//  if run with no args, runs all members;  server 0 runs Observer
//  if run with argument "n", just runs member n, with Observer
//	(run several copies in different windows)


package topovista.toksvc;

import java.io.*;



class expt2 {



static String[] servers;



public static void main(String args[])
throws Exception {

    Configuration cf = new Configuration("expt2.cfg");
    servers = cf.getArray("server");

    if (args.length > 0) {

	// one member
	int i = Integer.parseInt(args[0]);
	serve(i, true);

    } else {

	// all members
	for (int i = 0; i < servers.length; i++) {
	    serve(i, i == 0);
	}
    }

    for (;;) {
	try {
	    Thread.sleep(1000);
	    System.out.println("<tick>");
	} catch (InterruptedException e) {
	    System.out.println("<DING>");
	}
    }

}


static void serve(final int n, boolean observe) {

    try {
	Council c = new Council(servers, n);
	Leader l = new Director(c) {
	    void accede() {
		System.out.println("\t\tI'M IN CHARGE");
		super.accede();
	    }
	    void abdicate() {
		System.out.println("\t\tI'M OUTA HERE");
		super.abdicate();
	    }
	};
	Server ts = new Server(c);

	if (observe) {
	    new Observer(new PrintWriter(System.out), c);
	}
    } catch (Exception e) {
	Util.abort("expt2", e);
    };
}



} // class expt2
