//  tToken.java -- tests the Token class

//  mainly tests that the hashing function & sequence generation don't change


package topovista.toksvc;	// has to be: uses non-public interfaces

class tToken {


static byte[] sstates = {
    Server.READY,
    Server.READY,
    Server.DOWN,
    Server.DOWN,
    Server.READY,
    Server.DOWN,
    Server.BOOTING,
    Server.READY,
    Server.BOOTING,
    Server.READY,
    };

static Token toks[] = {
    new Token("one", null),
    new Token("two", "".getBytes()),
    new Token("three", "333".getBytes()),
    new Token("four", "4774".getBytes()),
};


public static void main(String args[]) throws Exception {

    test("a");
    test("b");
    test("c");
    test("d");
    test("e");
    test("f");
    test("g");
    test("h");
    test("i");
    test("j");
    test("ham");
    test("cheese");
    test("onions");
    test("tomato");
    test("garlic");
    test("sausage");
    test("pepperoni");
    test("mushrooms");
    test("bellpepper");
    test("massachusetts!");

    System.out.println();

    Pickle p = new Pickle();
    for (int i = 0; i < toks.length; i++) {
	toks[i].pickle(p);
    }
    byte[] b = p.toByteArray();
    System.out.println("Pickled size: " + b.length);
    p = new Pickle(b);

    for (int i = 0; i < toks.length; i++) {
	Token t = toks[i];
	String ts = new String(t.getData());
	Token u = new Token(p);
	String us = new String(u.getData());
	if (! (t.name.equals(u.name) && ts.equals(us))) {
	    System.out.print("ERROR>\t");
	}
	System.out.println(t + " <" + ts + "> " + u + " <" + us + ">");
    }
}


static Token tprev;

static void test(String name) {		// test token of a given name

    Token t = new Token(name, null);
    short[] seq = t.sequence(sstates.length);
    System.out.print(
	pad(t.hashCode(), -10) + "  " +
	pad(t.toString(), 22) +
	pad(t.primary(sstates.length), -2) + "->" +
	pad(t.server(sstates), 3));
    for (int i = 0; i < sstates.length; i++) {
	int j = seq[i];
	System.out.print(pad(j, -2) + stchar(sstates[j]));
	}
    System.out.println();
}



static char stchar(int i) {
    switch (i) {
	case Server.DOWN:	return '-';
	case Server.BOOTING:	return '=';
	case Server.READY:	return '+';
	default:		return '?';
    }
}


//  pad String s to size w; pad on left if w is negative

static String pad(String s, int w) {

    int n = s.length();

    if (w >= 0) {
	// pad on right
	if (n >= w) {
	    return s;
	}
	StringBuffer b = new StringBuffer(s);
	for (int i = n; i < w; i++) {
	    b.append(' ');
	}
	return b.toString();

    } else {
	// w<0; pad on left
	w = -w;
	if (n >= w) {
	    return s;
	}
	StringBuffer b = new StringBuffer(w);
	for (int i = n; i < w; i++) {
	    b.append(' ');
	}
	return b.append(s).toString();
    }
}

static String pad(int n, int w) {
    return pad(Integer.toString(n), w);
}


} // class tToken
