package topovista.tvsucker;

import java.io.*;



/**
 * Defines the interface for Reader classes.
 */
abstract class Reader {



/**
 *  Retrieve the specified tile.
 */
abstract public void fetch(Tile t) throws Exception;



/**
 *  Loads a Tile from an open InputStream.
 */
protected void loadFile(InputStream in, Tile t) throws Exception {
    DataInputStream din = new DataInputStream(in);
    for (;;) {
	byte[] magic = new byte[4];
	try {
	    din.readFully(magic);
	} catch (EOFException e) {
	    break;
	}
	if (! (new String(magic)).equals("TV4F")) {
	    throw new Error("unmagical header");
	}
	int v = din.readInt();
	int flag = v >>> 24;
	int len = v & 0x00FFFFFF;
	byte data[] = new byte[len - 8];
	din.readFully(data);
	t.got(flag, len);
    }
    din.close();
}



} // class Reader
